## pytorch 2.1.2+dfsg

=== requirements.txt ===
# Python dependencies required for development
astunparse
expecttest
hypothesis
numpy
psutil
pyyaml
requests
setuptools
types-dataclasses
typing-extensions
sympy
filelock
networkx
jinja2
fsspec
# setuptools was removed from default python install
setuptools ; python_version >= "3.12"

=== c10/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18 FATAL_ERROR)
project(c10 CXX)

set(CMAKE_CXX_STANDARD 17 CACHE STRING "The C++ standard whose features are requested to build this target.")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Main build file for the C10 library.
#
# Note that the C10 library should maintain minimal dependencies - especially,
# it should not depend on any library that is implementation specific or
# backend specific. It should in particular NOT be dependent on any generated
# protobuf header files, because protobuf header files will transitively force
# one to link against a specific protobuf version.

# ---[ Configure macro file.
set(C10_USE_GFLAGS ${USE_GFLAGS}) # used in cmake_macros.h.in
set(C10_USE_GLOG ${USE_GLOG}) # used in cmake_macros.h.in
set(C10_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS}) # used in cmake_macros.h.in
set(C10_USE_NUMA ${USE_NUMA})
set(C10_USE_MSVC_STATIC_RUNTIME ${CAFFE2_USE_MSVC_STATIC_RUNTIME})
configure_file(
    ${CMAKE_CURRENT_LIST_DIR}/macros/cmake_macros.h.in
    ${CMAKE_BINARY_DIR}/c10/macros/cmake_macros.h)

# Note: if you want to add ANY dependency to the c10 library, make sure you
# check with the core PyTorch developers as the dependency will be
# transitively passed on to all libraries dependent on PyTorch.
file(GLOB C10_SRCS
        *.cpp
        core/*.cpp
        core/impl/*.cpp
        core/impl/cow/*.cpp
        mobile/*.cpp
        macros/*.cpp
        util/*.cpp
        )
file(GLOB C10_HEADERS
        *.h
        core/*.h
        core/impl/*.h
        core/impl/cow/*.h
        mobile/*.h
        macros/*.h
        util/*.h
        )
add_library(c10 ${C10_SRCS} ${C10_HEADERS})
if(HAVE_SOVERSION)
  set_target_properties(c10 PROPERTIES
      VERSION ${TORCH_VERSION} SOVERSION ${TORCH_SOVERSION})
endif()
# If building shared library, set dllimport/dllexport proper.
target_compile_options(c10 PRIVATE "-DC10_BUILD_MAIN_LIB")
# Enable hidden visibility if compiler supports it.
if(${COMPILER_SUPPORTS_HIDDEN_VISIBILITY})
  target_compile_options(c10 PRIVATE "-fvisibility=hidden")
endif()

option(C10_USE_IWYU "Use include-what-you-use to clean up header inclusion" OFF)
if(C10_USE_IWYU)
  find_program(iwyu NAMES include-what-you-use)
  if(iwyu)
    set(iwyu_cmd
        "include-what-you-use"
        "-Xiwyu"
        "--transitive_includes_only"
        "-Xiwyu"
        "--no_fwd_decls"
        "-Xiwyu"
        "--prefix_header_includes=keep"
        "-Xiwyu"
        "--mapping_file=${CMAKE_CURRENT_LIST_DIR}/../tools/iwyu/all.imp"
        )
    set_property(TARGET c10 PROPERTY CXX_INCLUDE_WHAT_YOU_USE ${iwyu_cmd})
  endif()
endif()

if(WERROR)
  target_compile_options_if_supported(c10 PRIVATE "-Werror=sign-compare")
  target_compile_options_if_supported(c10 PRIVATE "-Werror=shadow")
endif()

# ---[ Dependency of c10
if(${USE_GFLAGS})
   target_link_libraries(c10 PUBLIC gflags)
endif()

if(${USE_GLOG})
    target_link_libraries(c10 PUBLIC glog::glog)
endif()
target_link_libraries(c10 PRIVATE fmt::fmt-header-only)

find_package(Backtrace)
if(Backtrace_FOUND)
  target_include_directories(c10 PRIVATE ${Backtrace_INCLUDE_DIRS})
  target_link_libraries(c10 PRIVATE ${Backtrace_LIBRARIES})
  target_compile_definitions(c10 PRIVATE SUPPORTS_BACKTRACE=1)
else()
  target_compile_definitions(c10 PRIVATE SUPPORTS_BACKTRACE=0)
endif()

if(USE_NUMA)
  message(STATUS "NUMA paths:")
  message(STATUS ${Numa_INCLUDE_DIR})
  message(STATUS ${Numa_LIBRARIES})
  include_directories(SYSTEM ${Numa_INCLUDE_DIR})
  target_link_libraries(c10 PRIVATE ${Numa_LIBRARIES})
else()
  message(STATUS "don't use NUMA")
endif()

if(USE_MIMALLOC)
  target_link_libraries(c10 PRIVATE "mimalloc-static")
  add_dependencies(c10 mimalloc-static)
endif()

if(ANDROID)
    target_link_libraries(c10 PRIVATE log)
endif()

target_include_directories(
    c10 PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../>
    $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}>
    $<INSTALL_INTERFACE:include>)

add_subdirectory(test)
add_subdirectory(benchmark)

if(USE_CUDA)
  add_subdirectory(cuda)
endif()

if(USE_ROCM)
  # NB: This directory is generated by the HIPIFY script; it's
  # not checked in
  add_subdirectory(hip)
endif()

# ---[ Installation
# Note: for now, we will put all export path into one single Caffe2Targets group
# to deal with the cmake deployment need. Inside the Caffe2Targets set, the
# individual libraries like libc10.so and libcaffe2.so are still self-contained.
install(TARGETS c10 EXPORT Caffe2Targets DESTINATION lib)
install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        DESTINATION include
        FILES_MATCHING PATTERN "*.h")
install(FILES ${CMAKE_BINARY_DIR}/c10/macros/cmake_macros.h
        DESTINATION include/c10/macros)

if(MSVC AND C10_BUILD_SHARED_LIBS)
  install(FILES $<TARGET_PDB_FILE:c10> DESTINATION lib OPTIONAL)
endif()

=== functorch/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
project(functorch)
set(CMAKE_CXX_STANDARD 17)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(FT_DIR csrc)
file(GLOB_RECURSE FT_SOURCES ${FT_DIR}/*.cpp)

add_library(${PROJECT_NAME} MODULE ${FT_SOURCES})
target_include_directories(${PROJECT_NAME} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_compile_definitions(${PROJECT_NAME} PRIVATE FUNCTORCH_BUILD_MAIN_LIB)
target_compile_definitions(${PROJECT_NAME} PRIVATE TORCH_EXTENSION_NAME=_C)
target_compile_definitions(${PROJECT_NAME} PRIVATE TORCH_API_INCLUDE_EXTENSION_H)
target_compile_options(${PROJECT_NAME} PRIVATE ${TORCH_PYTHON_COMPILE_OPTIONS})
target_compile_options_if_supported(${PROJECT_NAME} "-Wmissing-prototypes")
target_compile_options_if_supported(${PROJECT_NAME} "-Werror=missing-prototypes")
target_link_libraries(${PROJECT_NAME} PRIVATE torch torch_python)
target_link_libraries(${PROJECT_NAME} PRIVATE pybind::pybind11)

set_target_properties(${PROJECT_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY
      ${CMAKE_BINARY_DIR}/functorch)
set_target_properties(${PROJECT_NAME} PROPERTIES INSTALL_RPATH "${_rpath_portable_origin}/../torch/lib")

# Copy-pasted prefix/suffix logic for Python extensions from
# https://github.com/pytorch/pytorch/blob/33bb8ae350611760139457b85842b1d7edf9aa11/caffe2/CMakeLists.txt#L1975
# https://github.com/pytorch/pytorch/blob/33bb8ae350611760139457b85842b1d7edf9aa11/caffe2/CMakeLists.txt#L2022
# TODO: It would be good to be able to use Python3_add_library target, but it does not work in many cases
set_target_properties(${PROJECT_NAME} PROPERTIES PREFIX "" DEBUG_POSTFIX "")
if(WIN32)
  set_target_properties(${PROJECT_NAME} PROPERTIES SUFFIX ".pyd")
else()
  set_target_properties(${PROJECT_NAME} PROPERTIES SUFFIX ".so")
endif()
# Needed to link functorch on MacOS
if(NOT ${TORCH_PYTHON_LINK_FLAGS} STREQUAL "")
  set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS ${TORCH_PYTHON_LINK_FLAGS})
endif()
install(TARGETS ${PROJECT_NAME} DESTINATION "${CMAKE_CURRENT_SOURCE_DIR}")

=== torch/CMakeLists.txt ===
# This file used to build libtorch.so.
# Now it only builds the Torch python bindings.

if(NOT CAFFE2_CMAKE_BUILDING_WITH_MAIN_REPO)
  cmake_minimum_required(VERSION 3.18 FATAL_ERROR)
  project(torch CXX C)
  find_package(torch REQUIRED)
  option(USE_CUDA "Use CUDA" ON)
  set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
endif()

if(NOT BUILD_PYTHON)
  return()
endif()

if(USE_TBB)
  include_directories(${TBB_INCLUDE_DIR})
endif()

set(TORCH_SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
set(TORCH_ROOT "${TORCH_SRC_DIR}/..")

if(NOT TORCH_INSTALL_LIB_DIR)
  set(TORCH_INSTALL_LIB_DIR lib)
endif()

if(MSVC)
    set(LIBSHM_SUBDIR libshm_windows)
else()
    set(LIBSHM_SUBDIR libshm)
endif()

set(LIBSHM_SRCDIR ${TORCH_SRC_DIR}/lib/${LIBSHM_SUBDIR})
add_subdirectory(${LIBSHM_SRCDIR})


# Generate files
set(TOOLS_PATH "${TORCH_ROOT}/tools")


set(TORCH_PYTHON_SRCS
    ${GENERATED_THNN_CXX}
    ${GENERATED_CXX_PYTHON}
    )
append_filelist("libtorch_python_core_sources" TORCH_PYTHON_SRCS)

# NB: This has to match the condition under which the JIT test directory
#     is included (at the time of writing that's in caffe2/CMakeLists.txt).
if(BUILD_TEST)
    add_definitions(-DBUILDING_TESTS)
    list(APPEND TORCH_PYTHON_SRCS
      ${TORCH_ROOT}/test/cpp/jit/torch_python_test.cpp
      )
endif()

set(TORCH_PYTHON_INCLUDE_DIRECTORIES
    ${PYTHON_INCLUDE_DIR}

    ${TORCH_ROOT}
    ${TORCH_ROOT}/aten/src
    ${TORCH_ROOT}/aten/src/TH

    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/aten/src
    ${CMAKE_BINARY_DIR}/caffe2/aten/src
    ${CMAKE_BINARY_DIR}/third_party
    ${CMAKE_BINARY_DIR}/third_party/onnx

    ${TORCH_ROOT}/third_party/valgrind-headers

    ${TORCH_ROOT}/third_party/gloo
    ${TORCH_ROOT}/third_party/onnx
    ${TORCH_ROOT}/third_party/flatbuffers/include
    ${TORCH_ROOT}/third_party/kineto/libkineto/include

    ${TORCH_SRC_DIR}/csrc
    ${TORCH_SRC_DIR}/csrc/api/include
    ${TORCH_SRC_DIR}/lib
    )

list(APPEND TORCH_PYTHON_INCLUDE_DIRECTORIES ${LIBSHM_SRCDIR})

set(TORCH_PYTHON_LINK_LIBRARIES
    python::python
    pybind::pybind11
    shm
    fmt::fmt-header-only
    ATEN_CPU_FILES_GEN_LIB)

if(USE_ASAN AND TARGET Sanitizer::address)
  list(APPEND TORCH_PYTHON_LINK_LIBRARIES Sanitizer::address)
endif()
if(USE_ASAN AND TARGET Sanitizer::undefined)
  list(APPEND TORCH_PYTHON_LINK_LIBRARIES Sanitizer::undefined)
endif()
if(USE_TSAN AND TARGET Sanitizer::thread)
  list(APPEND TORCH_PYTHON_LINK_LIBRARIES Sanitizer::thread)
endif()

set(TORCH_PYTHON_COMPILE_DEFINITIONS)

set(TORCH_PYTHON_PUBLIC_COMPILE_DEFINITIONS)

set(TORCH_PYTHON_COMPILE_OPTIONS)

set(TORCH_PYTHON_LINK_FLAGS "")

if(MSVC)
    string(APPEND TORCH_PYTHON_LINK_FLAGS " /NODEFAULTLIB:LIBCMT.LIB")
    list(APPEND TORCH_PYTHON_LINK_LIBRARIES ${PYTHON_LIBRARIES} onnx_library)
    if(NOT CMAKE_BUILD_TYPE MATCHES "Release")
      string(APPEND TORCH_PYTHON_LINK_FLAGS " /DEBUG:FULL")
    endif()
elseif(APPLE)
    string(APPEND TORCH_PYTHON_LINK_FLAGS " -undefined dynamic_lookup")
else()
    list(APPEND TORCH_PYTHON_COMPILE_OPTIONS
      -fno-strict-aliasing
      -Wno-strict-aliasing)
endif()

if(USE_ITT)
  list(APPEND TORCH_PYTHON_SRCS
    ${TORCH_SRC_DIR}/csrc/itt.cpp
  )
  list(APPEND TORCH_PYTHON_COMPILE_DEFINITIONS USE_ITT)
endif()

if(USE_CUDA)
    include(${TORCH_ROOT}/cmake/public/cuda.cmake)
    append_filelist("libtorch_python_cuda_core_sources" TORCH_PYTHON_SRCS)
    list(APPEND TORCH_PYTHON_SRCS ${GENERATED_THNN_CXX_CUDA})

    list(APPEND TORCH_PYTHON_COMPILE_DEFINITIONS USE_CUDA)
    if(USE_CUDNN)
        list(APPEND TORCH_PYTHON_LINK_LIBRARIES torch::cudnn)
        list(APPEND TORCH_PYTHON_COMPILE_DEFINITIONS USE_CUDNN)
    endif()

    list(APPEND TORCH_PYTHON_LINK_LIBRARIES torch::nvtoolsext)
endif()

if(USE_ROCM)
    append_filelist("libtorch_python_cuda_core_sources" TORCH_PYTHON_SRCS)
    list(APPEND TORCH_PYTHON_SRCS ${GENERATED_THNN_CXX_CUDA})

    list(APPEND TORCH_PYTHON_COMPILE_DEFINITIONS
      USE_ROCM
      __HIP_PLATFORM_HCC__
      )
    list(APPEND TORCH_PYTHON_LINK_LIBRARIES ${ROCM_ROCTX_LIB})
endif()

if(USE_EXPERIMENTAL_CUDNN_V8_API)
    list(APPEND TORCH_PYTHON_COMPILE_DEFINITIONS USE_EXPERIMENTAL_CUDNN_V8_API)
endif()

if(USE_CUDNN OR USE_ROCM)
    list(APPEND TORCH_PYTHON_SRCS
      ${TORCH_SRC_DIR}/csrc/cuda/shared/cudnn.cpp
      )
    if(USE_STATIC_CUDNN)
        set_source_files_properties(
          ${TORCH_SRC_DIR}/csrc/cuda/shared/cudnn.cpp
          PROPERTIES COMPILE_DEFINITIONS "USE_STATIC_CUDNN"
        )
    endif()
endif()

if(USE_MPS)
    list(APPEND TORCH_PYTHON_SRCS ${MPS_PYTHON_SRCS})
endif()

if(USE_VALGRIND AND NOT WIN32)
    list(APPEND TORCH_PYTHON_COMPILE_DEFINITIONS USE_VALGRIND)
endif()

# In the most recent CMake versions, a new 'TRANSFORM' subcommand of 'list' allows much of the boilerplate of defining the lists
# of type stub files to be omitted.
# For compatibility with older CMake versions, we omit it for now, but leave it as a comment in case compatibility with the older
# CMake versions is eventually dropped.
# set(Modules
#     __init__
#     activation
#     adaptive
#     batchnorm
#     container
#     conv
#     distance
#     dropout
#     fold
#     instancenorm
#     linear
#     loss
#     module
#     normalization
#     padding
#     pixelshuffle
#     pooling
#     rnn
#     sparse
#     upsampling
# )
# list(TRANSFORM Modules PREPEND "${TORCH_SRC_DIR}/nn/modules/")
add_custom_target(torch_python_stubs DEPENDS
    "${TORCH_SRC_DIR}/_C/__init__.pyi"
    "${TORCH_SRC_DIR}/_C/_VariableFunctions.pyi"
    "${TORCH_SRC_DIR}/nn/functional.pyi"
    "${TORCH_SRC_DIR}/utils/data/datapipes/datapipe.pyi"
)

file(GLOB_RECURSE torchgen_python "${PROJECT_SOURCE_DIR}/torchgen/*.py")
file(GLOB_RECURSE autograd_python "${TOOLS_PATH}/autograd/*.py")
file(GLOB_RECURSE pyi_python "${TOOLS_PATH}/pyi/*.py")
add_custom_command(
    OUTPUT
    "${TORCH_SRC_DIR}/_C/__init__.pyi"
    "${TORCH_SRC_DIR}/_C/_VariableFunctions.pyi"
    "${TORCH_SRC_DIR}/nn/functional.pyi"
    COMMAND
    "${PYTHON_EXECUTABLE}" -mtools.pyi.gen_pyi
      --native-functions-path "aten/src/ATen/native/native_functions.yaml"
      --tags-path "aten/src/ATen/native/tags.yaml"
      --deprecated-functions-path "tools/autograd/deprecated.yaml"
    DEPENDS
      "${TORCH_SRC_DIR}/_C/__init__.pyi.in"
      "${TORCH_SRC_DIR}/_C/_VariableFunctions.pyi.in"
      "${TORCH_SRC_DIR}/nn/functional.pyi.in"
      "${TORCH_ROOT}/aten/src/ATen/native/native_functions.yaml"
      "${TORCH_ROOT}/aten/src/ATen/native/tags.yaml"
      "${TORCH_ROOT}/tools/autograd/deprecated.yaml"
      ${pyi_python}
      ${autograd_python}
      ${torchgen_python}
    WORKING_DIRECTORY
    "${TORCH_ROOT}"
)
file(GLOB_RECURSE datapipe_files "${TORCH_SRC_DIR}/utils/data/datapipes/*.py")
add_custom_command(
    OUTPUT
    "${TORCH_SRC_DIR}/utils/data/datapipes/datapipe.pyi"
    COMMAND
    "${PYTHON_EXECUTABLE}" ${TORCH_SRC_DIR}/utils/data/datapipes/gen_pyi.py
    DEPENDS
    "${TORCH_SRC_DIR}/utils/data/datapipes/datapipe.pyi.in"
    ${datapipe_files}
    WORKING_DIRECTORY
    "${TORCH_ROOT}"
)
if(USE_DISTRIBUTED)
    if(WIN32)
      append_filelist("libtorch_python_distributed_core_sources" TORCH_PYTHON_SRCS)
    else()
      append_filelist("libtorch_python_distributed_sources" TORCH_PYTHON_SRCS)
    endif()
    # Disable certain warnings for GCC-9.X
    if(CMAKE_COMPILER_IS_GNUCXX AND (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 9.0.0))
      set_source_files_properties(${TORCH_SRC_DIR}/csrc/distributed/autograd/init.cpp PROPERTIES COMPILE_FLAGS "-Wno-cast-function-type")
      set_source_files_properties(${TORCH_SRC_DIR}/csrc/distributed/rpc/testing/init.cpp PROPERTIES COMPILE_FLAGS "-Wno-cast-function-type")
      set_source_files_properties(${TORCH_SRC_DIR}/csrc/distributed/c10d/init.cpp PROPERTIES COMPILE_FLAGS "-Wno-cast-function-type")
    endif()
    # NCCL is a private dependency of libtorch, but libtorch_python includes
    # some private headers of libtorch, which in turn include NCCL. As a hacky
    # alternative to making NCCL a public dependency of libtorch, we make it
    # a private dependency of libtorch_python as well.
    if(USE_NCCL)
      list(APPEND TORCH_PYTHON_LINK_LIBRARIES __caffe2_nccl)
    endif()
    # Same for MPI.
    if(USE_MPI)
      list(APPEND TORCH_PYTHON_LINK_LIBRARIES ${MPI_CXX_LIBRARIES})
    endif()
    list(APPEND TORCH_PYTHON_COMPILE_DEFINITIONS USE_C10D)

endif()

if(USE_NCCL AND NOT WIN32)
    list(APPEND TORCH_PYTHON_SRCS
      ${TORCH_SRC_DIR}/csrc/cuda/python_nccl.cpp)
    list(APPEND TORCH_PYTHON_COMPILE_DEFINITIONS USE_NCCL)
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  # Workaround for https://gcc.gnu.org/bugzilla/show_bug.cgi?id=80947 in EmbeddingBag.cpp
  set_source_files_properties(${TORCH_SRC_DIR}/csrc/utils/throughput_benchmark.cpp PROPERTIES COMPILE_FLAGS -Wno-attributes)
endif()

if(NOT MSVC)
  # cudaProfilerInitialize must go away
  set_source_files_properties(${TORCH_SRC_DIR}/csrc/cuda/shared/cudart.cpp PROPERTIES COMPILE_FLAGS "-Wno-deprecated-declarations")
endif()

# coreml
if(USE_COREML_DELEGATE)
  list(APPEND TORCH_PYTHON_SRCS ${TORCH_SRC_DIR}/csrc/jit/backends/coreml/cpp/backend.cpp)
  list(APPEND TORCH_PYTHON_SRCS ${TORCH_SRC_DIR}/csrc/jit/backends/coreml/cpp/preprocess.cpp)
endif()


add_library(torch_python SHARED ${TORCH_PYTHON_SRCS})
# Avoid numpy for the DEPLOY build
if(USE_NUMPY)
  target_link_libraries(torch_python PRIVATE numpy::numpy)
  target_compile_definitions(torch_python PRIVATE USE_NUMPY)
endif()

if(HAVE_SOVERSION)
  set_target_properties(torch_python PROPERTIES
      VERSION ${TORCH_VERSION} SOVERSION ${TORCH_SOVERSION})
endif()
add_dependencies(torch_python torch_python_stubs)
add_dependencies(torch_python flatbuffers)


if(USE_PRECOMPILED_HEADERS)
  target_precompile_headers(torch_python PRIVATE
      "$<$<COMPILE_LANGUAGE:CXX>:ATen/ATen.h>")
endif()

if(NOT MSVC)
  target_compile_options(torch_python PRIVATE -Wno-unused-variable)
endif()

# Required workaround for generated sources
# See https://samthursfield.wordpress.com/2015/11/21/cmake-dependencies-between-targets-and-files-and-custom-commands/#custom-commands-in-different-directories
add_dependencies(torch_python generate-torch-sources)
set_source_files_properties(
    ${GENERATED_THNN_SOURCES}
    ${GENERATED_CXX_PYTHON}
    PROPERTIES GENERATED TRUE
    )

# Disable certain warnings for GCC-9.X
if(CMAKE_COMPILER_IS_GNUCXX AND (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 9.0.0))
  set_source_files_properties(${TORCH_SRC_DIR}/csrc/Module.cpp PROPERTIES COMPILE_FLAGS "-Wno-cast-function-type")
  set_source_files_properties(${TORCH_SRC_DIR}/csrc/autograd/python_variable.cpp PROPERTIES COMPILE_FLAGS "-Wno-cast-function-type")
endif()

# Preserve CUDA_GENCODE flags
if(USE_CUDA)
  torch_cuda_get_nvcc_gencode_flag(_ARCH_FLAGS)
  set_source_files_properties(${TORCH_SRC_DIR}/csrc/cuda/Module.cpp PROPERTIES COMPILE_FLAGS "-DCUDA_ARCH_FLAGS=\"${_ARCH_FLAGS_readable}\"")
endif()

# Preserve HIP arch flags
if(USE_ROCM)
  string(REPLACE ";" " " PYTORCH_ROCM_ARCH_readable "${PYTORCH_ROCM_ARCH}")
  set_source_files_properties(${TORCH_SRC_DIR}/csrc/cuda/Module.cpp PROPERTIES COMPILE_FLAGS "-DCUDA_ARCH_FLAGS=\"${PYTORCH_ROCM_ARCH_readable}\"")
endif()

target_compile_definitions(torch_python PRIVATE "-DTHP_BUILD_MAIN_LIB")

target_link_libraries(torch_python PRIVATE torch_library ${TORCH_PYTHON_LINK_LIBRARIES})

target_compile_definitions(torch_python PRIVATE ${TORCH_PYTHON_COMPILE_DEFINITIONS})

target_compile_definitions(torch_python PUBLIC ${TORCH_PYTHON_PUBLIC_COMPILE_DEFINITIONS})

target_compile_options(torch_python PRIVATE ${TORCH_PYTHON_COMPILE_OPTIONS})

target_include_directories(torch_python PUBLIC ${TORCH_PYTHON_INCLUDE_DIRECTORIES})

if(USE_UCC)
  target_link_libraries(torch_python PRIVATE __caffe2_ucc)
  target_compile_definitions(torch_python PRIVATE USE_UCC)
endif()

if(BUILD_ONEDNN_GRAPH)
  target_compile_definitions(torch_python PRIVATE "-DBUILD_ONEDNN_GRAPH")

=== aten/src/ATen/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18 FATAL_ERROR)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})

if(NOT MSVC)
  string(APPEND CMAKE_CXX_FLAGS " -Wno-ignored-qualifiers")
  string(APPEND CMAKE_C_FLAGS " -Wno-ignored-qualifiers")
  string(APPEND CMAKE_CXX_FLAGS " -Wno-absolute-value")
  string(APPEND CMAKE_C_FLAGS " -Wno-absolute-value")
endif(NOT MSVC)

# Can be compiled standalone
if(NOT AT_INSTALL_BIN_DIR OR NOT AT_INSTALL_LIB_DIR OR NOT AT_INSTALL_INCLUDE_DIR OR NOT AT_INSTALL_SHARE_DIR)
  set(AT_INSTALL_BIN_DIR "bin" CACHE PATH "AT install binary subdirectory")
  set(AT_INSTALL_LIB_DIR "lib" CACHE PATH "AT install library subdirectory")
  set(AT_INSTALL_INCLUDE_DIR "include" CACHE PATH "AT install include subdirectory")
  set(AT_INSTALL_SHARE_DIR "share" CACHE PATH "AT install include subdirectory")
endif()

# These flag are used in Config but set externally. We must normalize them to
# 0/1 otherwise `#if ON` will be evaluated to false.
macro(set_bool OUT IN)
  if(${IN})
    set(${OUT} 1)
  else()
    set(${OUT} 0)
  endif()
endmacro()

set_bool(AT_BUILD_WITH_BLAS USE_BLAS)
set_bool(AT_BUILD_WITH_LAPACK USE_LAPACK)
set_bool(AT_BLAS_F2C BLAS_F2C)
set_bool(AT_BLAS_USE_CBLAS_DOT BLAS_USE_CBLAS_DOT)
set_bool(AT_MAGMA_ENABLED USE_MAGMA)
set_bool(CAFFE2_STATIC_LINK_CUDA_INT CAFFE2_STATIC_LINK_CUDA)
set_bool(AT_CUDNN_ENABLED CAFFE2_USE_CUDNN)
set_bool(AT_CUSPARSELT_ENABLED CAFFE2_USE_CUSPARSELT)

configure_file(Config.h.in "${CMAKE_CURRENT_SOURCE_DIR}/Config.h")
# TODO: Do not generate CUDAConfig.h for ROCm BUILDS
# At the moment, `jit_macors.h` include CUDAConfig.h for both CUDA and HIP builds
if(USE_CUDA OR USE_ROCM)
  configure_file(cuda/CUDAConfig.h.in "${CMAKE_CURRENT_SOURCE_DIR}/cuda/CUDAConfig.h")
endif()
if(USE_ROCM)
  configure_file(hip/HIPConfig.h.in "${CMAKE_CURRENT_SOURCE_DIR}/hip/HIPConfig.h")
endif()

# NB: If you edit these globs, you'll have to update setup.py package_data as well
file(GLOB_RECURSE ATen_CORE_HEADERS  "core/*.h")
file(GLOB_RECURSE ATen_CORE_SRCS "core/*.cpp")
if(NOT BUILD_LITE_INTERPRETER)
  file(GLOB_RECURSE ATen_CORE_TEST_SRCS "core/*_test.cpp")
endif()
EXCLUDE(ATen_CORE_SRCS "${ATen_CORE_SRCS}" ${ATen_CORE_TEST_SRCS})
# Exclude TensorImpl_test.cpp if compiling without Caffe2
if(NOT BUILD_CAFFE2 AND NOT BUILD_LITE_INTERPRETER)
  file(GLOB_RECURSE ATen_CORE_EXCLUDED_TEST_SRCS "core/TensorImpl_test.cpp")
  EXCLUDE(ATen_CORE_TEST_SRCS "${ATen_CORE_TEST_SRCS}" ${ATen_CORE_EXCLUDED_TEST_SRCS})
endif()

file(GLOB base_h "*.h" "detail/*.h" "cpu/*.h" "cpu/vec/vec512/*.h" "cpu/vec/vec256/*.h" "cpu/vec/vec256/vsx/*.h" "cpu/vec/*.h" "quantized/*.h" "functorch/*.h")
file(GLOB base_cpp "*.cpp" "detail/*.cpp" "cpu/*.cpp" "functorch/*.cpp")
file(GLOB cuda_h "cuda/*.h" "cuda/detail/*.h" "cuda/*.cuh" "cuda/detail/*.cuh")
file(GLOB cuda_cpp "cuda/*.cpp" "cuda/detail/*.cpp")
file(GLOB cuda_nvrtc_stub_h "cuda/nvrtc_stub/*.h")
file(GLOB cuda_nvrtc_stub_cpp "cuda/nvrtc_stub/*.cpp")
file(GLOB cuda_cu "cuda/*.cu" "cuda/detail/*.cu")
file(GLOB cudnn_h "cudnn/*.h" "cudnn/*.cuh")
file(GLOB cudnn_cpp "cudnn/*.cpp")
file(GLOB ops_h "ops/*.h")

file(GLOB hip_h "hip/*.h" "hip/detail/*.h" "hip/*.cuh" "hip/detail/*.cuh" "hip/impl/*.h")
file(GLOB hip_cpp "hip/*.cpp" "hip/detail/*.cpp" "hip/impl/*.cpp")
list(REMOVE_ITEM hip_cpp "${CMAKE_CURRENT_SOURCE_DIR}/hip/detail/LazyNVRTC.cpp")
file(GLOB hip_hip "hip/*.hip" "hip/detail/*.hip" "hip/impl/*.hip")
file(GLOB hip_nvrtc_stub_h "hip/nvrtc_stub/*.h")
file(GLOB hip_nvrtc_stub_cpp "hip/nvrtc_stub/*.cpp")
file(GLOB miopen_h "miopen/*.h")
file(GLOB miopen_cpp "miopen/*.cpp")

file(GLOB mkl_cpp "mkl/*.cpp")
file(GLOB mkldnn_cpp "mkldnn/*.cpp")

file(GLOB native_cpp "native/*.cpp")
file(GLOB native_mkl_cpp "native/mkl/*.cpp")
file(GLOB native_mkldnn_cpp "native/mkldnn/*.cpp")
file(GLOB vulkan_cpp "vulkan/*.cpp")
file(GLOB native_vulkan_cpp "native/vulkan/*.cpp" "native/vulkan/api/*.cpp" "native/vulkan/impl/*.cpp" "native/vulkan/ops/*.cpp")

# Metal
file(GLOB metal_h "metal/*.h")
file(GLOB metal_cpp "metal/*.cpp")
file(GLOB_RECURSE native_metal_h "native/metal/*.h")
file(GLOB metal_test_srcs "native/metal/mpscnn/tests/*.mm")
file(GLOB_RECURSE native_metal_srcs "native/metal/*.mm" "native/metal/*.cpp")
EXCLUDE(native_metal_srcs "${native_metal_srcs}" ${metal_test_srcs})
file(GLOB metal_prepack_h "native/metal/MetalPrepackOpContext.h")
file(GLOB metal_prepack_cpp "native/metal/MetalPrepackOpRegister.cpp")

file(GLOB native_ao_sparse_cpp
            "native/ao_sparse/*.cpp"
            "native/ao_sparse/cpu/*.cpp"
            "native/ao_sparse/quantized/*.cpp"
            "native/ao_sparse/quantized/cpu/*.cpp")
# MPS
file(GLOB mps_cpp "mps/*.cpp")
file(GLOB mps_mm "mps/*.mm")
file(GLOB mps_h "mps/*.h")
file(GLOB_RECURSE native_mps_cpp "native/mps/*.cpp")
file(GLOB_RECURSE native_mps_mm "native/mps/*.mm")
file(GLOB_RECURSE native_mps_h "native/mps/*.h")

file(GLOB native_sparse_cpp "native/sparse/*.cpp")
file(GLOB native_quantized_cpp
            "native/quantized/*.cpp"
            "native/quantized/cpu/*.cpp")
file(GLOB native_nested_cpp "native/nested/*.cpp")
file(GLOB native_transformers_cpp "native/transformers/*.cpp")

file(GLOB native_h "native/*.h")
file(GLOB native_ao_sparse_h
            "native/ao_sparse/*.h"
            "native/ao_sparse/cpu/*.h"
            "native/ao_sparse/quantized/*.h"
            "native/ao_sparse/quantized/cpu/*.h")
file(GLOB native_quantized_h "native/quantized/*.h" "native/quantized/cpu/*.h" "native/quantized/cudnn/*.h")
file(GLOB native_cpu_h "native/cpu/*.h")
file(GLOB native_utils_h "native/utils/*.h")

file(GLOB native_cuda_cu "native/cuda/*.cu")
file(GLOB native_cuda_cpp "native/cuda/*.cpp")
file(GLOB native_cuda_h "native/cuda/*.h" "native/cuda/*.cuh")
file(GLOB native_cuda_linalg_cpp "native/cuda/linalg/*.cpp")
file(GLOB native_hip_h "native/hip/*.h" "native/hip/*.cuh")
file(GLOB native_cudnn_cpp "native/cudnn/*.cpp")
file(GLOB native_sparse_cuda_cu "native/sparse/cuda/*.cu")
file(GLOB native_sparse_cuda_cpp "native/sparse/cuda/*.cpp")
file(GLOB native_quantized_cuda_cu "native/quantized/cuda/*.cu")
file(GLOB native_quantized_cuda_cpp "native/quantized/cuda/*.cpp")
file(GLOB native_quantized_cudnn_cpp "native/quantized/cudnn/*.cpp")
file(GLOB native_nested_cuda_cu "native/nested/cuda/*.cu")
file(GLOB native_nested_cuda_cpp "native/nested/cuda/*.cpp")

file(GLOB native_hip_hip "native/hip/*.hip")
file(GLOB native_hip_cpp "native/hip/*.cpp")
file(GLOB native_hip_linalg_cpp "native/hip/linalg/*.cpp")
file(GLOB native_miopen_cpp "native/miopen/*.cpp")
file(GLOB native_cudnn_hip_cpp "native/cudnn/hip/*.cpp")
file(GLOB native_nested_hip_hip "native/nested/hip/*.hip")
file(GLOB native_nested_hip_cpp "native/nested/hip/*.cpp")
file(GLOB native_sparse_hip_hip "native/sparse/hip/*.hip")
file(GLOB native_sparse_hip_cpp "native/sparse/hip/*.cpp")
file(GLOB native_quantized_hip_hip "native/quantized/hip/*.hip")
file(GLOB native_quantized_hip_cpp "native/quantized/hip/*.cpp")
file(GLOB native_transformers_cuda_cu "native/transformers/cuda/*.cu")
file(GLOB native_transformers_cuda_cpp "native/transformers/cuda/*.cpp")
file(GLOB native_transformers_hip_hip "native/transformers/hip/*.hip")
file(GLOB native_transformers_hip_cpp "native/transformers/hip/*.cpp")
file(GLOB native_quantized_cudnn_hip_cpp "native/quantized/cudnn/hip/*.cpp")
file(GLOB native_utils_cpp "native/utils/*.cpp")

# flash_attention sources
file(GLOB flash_attention_cuda_cu "native/transformers/cuda/flash_attn/*.cu")
file(GLOB flash_attention_cuda_cpp "native/transformers/cuda/flash_attn/*.cpp")

#Mem_eff attention sources
file(GLOB mem_eff_attention_cuda_cu "native/transformers/cuda/mem_eff_attention/*.cu")
file(GLOB mem_eff_attention_cuda_kernels_cu "native/transformers/cuda/mem_eff_attention/kernels/*.cu")
file(GLOB mem_eff_attention_cuda_cpp "native/transformers/cuda/mem_eff_attention/*.cpp")

if(USE_FLASH_ATTENTION)
  list(APPEND native_transformers_cuda_cu ${flash_attention_cuda_cu})
  list(APPEND native_transformers_cuda_cpp ${flash_attention_cuda_cpp})

  list(APPEND native_transformers_cuda_cu ${mem_eff_attention_cuda_cu})
  list(APPEND native_transformers_cuda_cu ${mem_eff_attention_cuda_kernels_cu})
  list(APPEND native_transformers_cuda_cpp ${mem_eff_attention_cuda_cpp})
  list(APPEND MEM_EFF_ATTENTION_CUDA_SOURCES ${native_transformers_cuda_cu} ${mem_eff_attention_cuda_cu} ${mem_eff_attention_cuda_kernels_cu})
endif()

# XNNPACK
file(GLOB native_xnnpack "native/xnnpack/*.cpp")

# Add files needed from jit folders
append_filelist("jit_core_headers" ATen_CORE_HEADERS)
append_filelist("jit_core_sources" ATen_CORE_SRCS)

add_subdirectory(quantized)
add_subdirectory(nnapi)

if(BUILD_LITE_INTERPRETER)
  set(all_cpu_cpp ${generated_sources} ${core_generated_sources} ${cpu_kernel_cpp})
  append_filelist("jit_core_sources" all_cpu_cpp)
  append_filelist("aten_cpu_source_non_codegen_list" all_cpu_cpp)
  append_filelist("aten_native_source_non_codegen_list" all_cpu_cpp)
else()
  set(
    all_cpu_cpp ${base_cpp} ${ATen_CORE_SRCS} ${native_cpp}
    ${native_ao_sparse_cpp} ${native_sparse_cpp} ${native_nested_cpp}
    ${native_quantized_cpp} ${native_mkl_cpp} ${native_mkldnn_cpp}
    ${native_transformers_cpp}
    ${native_utils_cpp} ${native_xnnpack} ${generated_sources} ${core_generated_sources}
    ${ATen_CPU_SRCS} ${ATen_QUANTIZED_SRCS} ${ATen_NNAPI_SRCS} ${cpu_kernel_cpp}
  )
endif()

if(USE_LIGHTWEIGHT_DISPATCH)
  set(all_cpu_cpp ${all_cpu_cpp} ${generated_unboxing_sources})
endif()
if(AT_MKL_ENABLED)
  set(all_cpu_cpp ${all_cpu_cpp} ${mkl_cpp})
endif()
if(AT_MKLDNN_ENABLED)
  set(all_cpu_cpp ${all_cpu_cpp} ${mkldnn_cpp})
endif()
if(USE_VULKAN)
  set(all_cpu_cpp ${all_cpu_cpp} ${vulkan_cpp} ${native_vulkan_cpp} ${vulkan_generated_cpp})
else()
  set(all_cpu_cpp ${all_cpu_cpp} ${vulkan_cpp})
endif()

# Metal
if(USE_PYTORCH_METAL_EXPORT)
  # Add files needed from exporting metal models(optimized_for_mobile)
  set(all_cpu_cpp ${all_cpu_cpp} ${metal_cpp} ${metal_prepack_cpp})
elseif(APPLE AND USE_PYTORCH_METAL)
  # Compile Metal kernels
  set(all_cpu_cpp ${all_cpu_cpp} ${metal_cpp} ${native_metal_srcs})
else()
  set(all_cpu_cpp ${all_cpu_cpp} ${metal_cpp})
endif()

if(USE_CUDA AND USE_ROCM)
  message(FATAL_ERROR "ATen doesn't not currently support simultaneously building with CUDA and ROCM")
endif()

if(USE_CUDA)
  list(APPEND ATen_CUDA_INCLUDE ${CMAKE_CURRENT_SOURCE_DIR}/cuda)
  list(APPEND ATen_CUDA_CU_SRCS
    ${cuda_cu}
    ${native_cuda_cu}
    ${native_nested_cuda_cu}
    ${native_sparse_cuda_cu}
    ${native_quantized_cuda_cu}
    ${native_transformers_cuda_cu}
    ${cuda_generated_sources}
  )
  list(APPEND ATen_CUDA_CPP_SRCS
    ${cuda_cpp}
    ${native_cuda_cpp}
    ${native_cudnn_cpp}
    ${native_miopen_cpp}
    ${native_nested_cuda_cpp}
    ${native_quantized_cuda_cpp}
    ${native_quantized_cudnn_cpp}
    ${native_sparse_cuda_cpp}
    ${native_transformers_cuda_cpp}
  )
  set(ATen_CUDA_LINALG_SRCS ${native_cuda_linalg_cpp})
  if(NOT BUILD_LAZY_CUDA_LINALG)
    list(APPEND ATen_CUDA_CU_SRCS ${native_cuda_linalg_cpp})
  endif()
  if(CAFFE2_USE_CUDNN)
    list(APPEND ATen_CUDA_CPP_SRCS ${cudnn_cpp})
  endif()

  append_filelist("aten_cuda_cu_source_list" ATen_CUDA_CU_SRCS)
  append_filelist("aten_cuda_with_sort_by_key_source_list" ATen_CUDA_SRCS_W_SORT_BY_KEY)
  append_filelist("aten_cuda_cu_with_sort_by_key_source_list" ATen_CUDA_CU_SRCS_W_SORT_BY_KEY)

  exclude(ATen_CUDA_CPP_SRCS "${ATen_CUDA_CPP_SRCS}"
      ${ATen_CUDA_CU_SRCS}
      ${ATen_CUDA_SRCS_W_SORT_BY_KEY} ${ATen_CUDA_CU_SRCS_W_SORT_BY_KEY})
  exclude(ATen_CUDA_CU_SRCS "${ATen_CUDA_CU_SRCS}"
      ${ATen_CUDA_SRCS_W_SORT_BY_KEY} ${ATen_CUDA_CU_SRCS_W_SORT_BY_KEY})
endif()

if(USE_ROCM)
  list(APPEND ATen_HIP_INCLUDE ${CMAKE_CURRENT_SOURCE_DIR}/hip)
  set(ATen_HIP_SRCS ${ATen_HIP_SRCS} ${hip_hip} ${native_hip_hip} ${native_nested_hip_hip} ${native_sparse_hip_hip} ${native_quantized_hip_hip} ${native_transformers_hip_hip})

=== benchmarks/dynamo/_onnx/requirements.txt ===
flatbuffers
coloredlogs
beartype
numpy==1.22.0
# Install pycocotools that otherwise fails in 'build repos' step.
pycocotools

=== test/cpp/aot_inductor/CMakeLists.txt ===

set(AOT_INDUCTOR_TEST_ROOT ${TORCH_ROOT}/test/cpp/aot_inductor)

# Build the cpp gtest binary containing the cpp-only tests.
set(INDUCTOR_TEST_SRCS
  ${AOT_INDUCTOR_TEST_ROOT}/test.cpp
)

add_executable(test_aot_inductor
  ${TORCH_ROOT}/test/cpp/common/main.cpp
  ${INDUCTOR_TEST_SRCS}
)

# TODO temporary until we can delete the old gtest polyfills.
target_compile_definitions(test_aot_inductor PRIVATE USE_GTEST)

# Define a custom command to generate the library
add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/libaot_inductor_output.so
        COMMAND python ${AOT_INDUCTOR_TEST_ROOT}/test.py
        DEPENDS ${AOT_INDUCTOR_TEST_ROOT}/test.py
)
add_custom_target(aot_inductor_output_target ALL
        DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/libaot_inductor_output.so)
add_dependencies(test_aot_inductor aot_inductor_output_target)

target_link_libraries(test_aot_inductor PRIVATE
  torch
  gtest
  ${CMAKE_CURRENT_BINARY_DIR}/libaot_inductor_output.so
)

if(USE_CUDA)
  target_link_libraries(test_aot_inductor PRIVATE
    ${C10_CUDA_BUILD_SHARED_LIBS}
    ${CUDA_LIBRARIES}
    ${CUDA_NVRTC_LIB}
    ${CUDA_CUDA_LIB}
    ${TORCH_CUDA_LIBRARIES}
  )

  target_include_directories(test_aot_inductor PRIVATE ${ATen_CUDA_INCLUDE})

  target_compile_definitions(test_aot_inductor PRIVATE USE_CUDA)
endif()

if(INSTALL_TEST)
  install(TARGETS test_aot_inductor DESTINATION bin)
  # Install PDB files for MSVC builds
  if(MSVC AND BUILD_SHARED_LIBS)
    install(FILES $<TARGET_PDB_FILE:test_aot_inductor> DESTINATION bin OPTIONAL)
  endif()
endif()

=== test/cpp/api/CMakeLists.txt ===
set(TORCH_API_TEST_DIR "${TORCH_ROOT}/test/cpp/api")
set(TORCH_API_TEST_SOURCES
  ${TORCH_ROOT}/test/cpp/common/main.cpp
  ${TORCH_API_TEST_DIR}/autograd.cpp
  ${TORCH_API_TEST_DIR}/any.cpp
  ${TORCH_API_TEST_DIR}/dataloader.cpp
  ${TORCH_API_TEST_DIR}/enum.cpp
  ${TORCH_API_TEST_DIR}/expanding-array.cpp
  ${TORCH_API_TEST_DIR}/fft.cpp
  ${TORCH_API_TEST_DIR}/functional.cpp
  ${TORCH_API_TEST_DIR}/jit.cpp
  ${TORCH_API_TEST_DIR}/memory.cpp
  ${TORCH_API_TEST_DIR}/meta_tensor.cpp
  ${TORCH_API_TEST_DIR}/misc.cpp
  ${TORCH_API_TEST_DIR}/module.cpp
  ${TORCH_API_TEST_DIR}/moduledict.cpp
  ${TORCH_API_TEST_DIR}/modulelist.cpp
  ${TORCH_API_TEST_DIR}/modules.cpp
  ${TORCH_API_TEST_DIR}/nested.cpp
  ${TORCH_API_TEST_DIR}/parameterdict.cpp
  ${TORCH_API_TEST_DIR}/parameterlist.cpp
  ${TORCH_API_TEST_DIR}/namespace.cpp
  ${TORCH_API_TEST_DIR}/nn_utils.cpp
  ${TORCH_API_TEST_DIR}/optim.cpp
  ${TORCH_API_TEST_DIR}/ordered_dict.cpp
  ${TORCH_API_TEST_DIR}/rnn.cpp
  ${TORCH_API_TEST_DIR}/sequential.cpp
  ${TORCH_API_TEST_DIR}/transformer.cpp
  ${TORCH_API_TEST_DIR}/serialize.cpp
  ${TORCH_API_TEST_DIR}/special.cpp
  ${TORCH_API_TEST_DIR}/static.cpp
  ${TORCH_API_TEST_DIR}/support.cpp
  ${TORCH_API_TEST_DIR}/tensor_cuda.cpp
  ${TORCH_API_TEST_DIR}/tensor_indexing.cpp
  ${TORCH_API_TEST_DIR}/tensor_options_cuda.cpp
  ${TORCH_API_TEST_DIR}/tensor_options.cpp
  ${TORCH_API_TEST_DIR}/tensor.cpp
  ${TORCH_API_TEST_DIR}/torch_include.cpp
  ${TORCH_API_TEST_DIR}/inference_mode.cpp
  ${TORCH_API_TEST_DIR}/grad_mode.cpp
  ${TORCH_API_TEST_DIR}/operations.cpp
)
if(USE_CUDA)
  list(APPEND TORCH_API_TEST_SOURCES ${TORCH_API_TEST_DIR}/parallel.cpp)
endif()

if(NOT USE_ROCM)
  list(APPEND TORCH_API_TEST_SOURCES ${TORCH_API_TEST_DIR}/init.cpp)
  list(APPEND TORCH_API_TEST_SOURCES ${TORCH_API_TEST_DIR}/integration.cpp)
endif()

add_executable(test_api ${TORCH_API_TEST_SOURCES})
target_include_directories(test_api PRIVATE ${ATen_CPU_INCLUDE})
target_link_libraries(test_api PRIVATE torch gtest)
if(NOT MSVC)
  target_compile_options_if_supported(test_api -Wno-unused-variable)
endif()

if(USE_CUDA)
  target_link_libraries(test_api PRIVATE
    ${CUDA_LIBRARIES}
    ${CUDA_NVRTC_LIB}
    ${CUDA_CUDA_LIB}
    ${TORCH_CUDA_LIBRARIES})

  target_compile_definitions(test_api PRIVATE "USE_CUDA")
endif()

# Workaround for https://github.com/pytorch/pytorch/issues/40941
if(USE_OPENMP AND CMAKE_COMPILER_IS_GNUCXX AND (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0.0))
  # Compiling transformer.cpp or pow_test.cpp with -O2+ and both -fuse-openmp and -faligned-newout any optimization
  # Fails with internal compiler error in gcc-7.5 or older
  # Workaround by compiling the tests without openmp (which they are not using anyway)
  set_property(TARGET test_api APPEND_STRING PROPERTY COMPILE_FLAGS "-fno-openmp")
endif()

if(NOT MSVC)
  # Clang has an unfixed bug leading to spurious missing braces
  # warnings, see https://bugs.llvm.org/show_bug.cgi?id=21629
  target_compile_options_if_supported(test_api "-Wno-missing-braces")
  # Considered to be flaky.  See the discussion at
  # https://github.com/pytorch/pytorch/pull/9608
  target_compile_options_if_supported(test_api "-Wno-maybe-uninitialized")
  # gcc gives nonsensical warnings about variadic.h
  target_compile_options_if_supported(test_api "-Wno-unused-but-set-parameter")
endif()

if(INSTALL_TEST)
  install(TARGETS test_api DESTINATION bin)
  # Install PDB files for MSVC builds
  if(MSVC AND BUILD_SHARED_LIBS)
    install(FILES $<TARGET_PDB_FILE:test_api> DESTINATION bin OPTIONAL)
  endif()
endif()

add_executable(parallel_benchmark ${TORCH_API_TEST_DIR}/parallel_benchmark.cpp)
target_include_directories(parallel_benchmark PRIVATE ${ATen_CPU_INCLUDE})
target_link_libraries(parallel_benchmark PRIVATE torch)

=== aten/src/ATen/test/CMakeLists.txt ===
if(MSVC)
  if(MSVC_VERSION LESS 1911)
    return()
  endif()
endif(MSVC)

list(APPEND ATen_CPU_TEST_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/Dict_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/Dimname_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/MaybeOwned_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/NamedTensor_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/apply_utils_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/atest.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basic.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/broadcast_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpu_generator_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpu_profiling_allocator_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpu_rng_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/dispatch_key_set_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/dlconvertor_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/extension_backend_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/half_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/ivalue_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lazy_tensor_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/math_kernel_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/memory_format_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/memory_overlapping_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mobile_memory_cleanup.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/native_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/operator_name_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/operators_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/packedtensoraccessor_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/pow_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/quantized_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/reduce_ops_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/reportMemoryUsage_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/scalar_tensor_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/scalar_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/StorageUtils_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/stride_properties_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/tensor_iterator_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/test_parallel.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/thread_init_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/type_ptr_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/type_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/undefined_tensor_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/variant_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/verify_api_visibility.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/legacy_vmap_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/weakref_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/wrapdim_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/xla_tensor_test.cpp
  # Fix this.
  # ${CMAKE_CURRENT_SOURCE_DIR}/xnnpack_test.cpp
  )

list(APPEND ATen_CUDA_TEST_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_apply_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_atomic_ops_test.cu
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_caching_host_allocator_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_complex_math_test.cu
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_complex_test.cu
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_cub_test.cu
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_device_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_distributions_test.cu
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_dlconvertor_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_generator_test.cu
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_half_test.cu
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_integer_divider_test.cu
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_optional_test.cu
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_packedtensoraccessor_test.cu
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_reportMemoryUsage_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_stream_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cuda_vectorized_test.cu)
if(CAFFE2_USE_CUDNN)
  list(APPEND ATen_CUDA_TEST_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/cuda_cudnn_test.cpp)
endif()

list(APPEND ATen_HIP_TEST_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/hip/hip_apply_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/hip/hip_complex_math_test.hip
  ${CMAKE_CURRENT_SOURCE_DIR}/hip/hip_complex_test.hip
  ${CMAKE_CURRENT_SOURCE_DIR}/hip/hip_distributions_test.hip
  ${CMAKE_CURRENT_SOURCE_DIR}/hip/hip_dlconvertor_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/hip/hip_generator_test.hip
  ${CMAKE_CURRENT_SOURCE_DIR}/hip/hip_half_test.hip
  ${CMAKE_CURRENT_SOURCE_DIR}/hip/hip_integer_divider_test.hip
  ${CMAKE_CURRENT_SOURCE_DIR}/hip/hip_optional_test.hip
  ${CMAKE_CURRENT_SOURCE_DIR}/hip/hip_packedtensoraccessor_test.hip
  ${CMAKE_CURRENT_SOURCE_DIR}/hip/hip_vectorized_test.hip)
# TODO: fix and enable these
#  ${CMAKE_CURRENT_SOURCE_DIR}/hip/hip_tensor_interop_test.cpp
#  ${CMAKE_CURRENT_SOURCE_DIR}/hip/hip_stream_test.cpp

list(APPEND ATen_VULKAN_TEST_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/vulkan_api_test.cpp)

list(APPEND ATen_MOBILE_TEST_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/cpu_caching_allocator_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpu_profiling_allocator_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/quantized_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/vec_test_all_types.cpp)

list(APPEND ATen_VEC_TEST_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/vec_test_all_types.cpp
  )

list(APPEND ATen_MPS_TEST_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/mps_test_print.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mps_test_allocator.cpp)
if(APPLE AND USE_MPS)
  list(APPEND ATen_MPS_TEST_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/mps_test_objc_interface.mm)
endif()

# Caffe2 specific tests
if(BUILD_CAFFE2)
  list(APPEND ATen_CPU_TEST_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/ExclusivelyOwned_test.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tensor_interop_test.cpp)
  list(APPEND ATen_CUDA_TEST_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/cuda_tensor_interop_test.cpp)
endif()


# ---[ Send the lists to the parent scope.
set(ATen_CPU_TEST_SRCS ${ATen_CPU_TEST_SRCS} PARENT_SCOPE)
set(ATen_CUDA_TEST_SRCS ${ATen_CUDA_TEST_SRCS} PARENT_SCOPE)
set(ATen_HIP_TEST_SRCS ${ATen_HIP_TEST_SRCS} PARENT_SCOPE)
set(ATen_VULKAN_TEST_SRCS ${ATen_VULKAN_TEST_SRCS} PARENT_SCOPE)
set(ATen_MOBILE_TEST_SRCS ${ATen_MOBILE_TEST_SRCS} PARENT_SCOPE)
set(ATen_VEC_TEST_SRCS ${ATen_VEC_TEST_SRCS} PARENT_SCOPE)
set(ATen_MPS_TEST_SRCS ${ATen_MPS_TEST_SRCS} PARENT_SCOPE)

=== debian/changelog ===
pytorch (2.1.2+dfsg-4ubuntu1) oracular; urgency=medium

  * Fix FTBFS with LLVM 18. (LP: #2067720)
    - d/p/0011-Update-caffe2-with-LLVM-18-API-change-109408.patch:
    - d/p/0012-Fix-build-for-llvm-18-115652.patch:
    - d/p/0013-Update-for-an-API-change-in-LLVM-18.-117086.patch:
    - d/p/0014-Replaced-getInt8PtrTy-with-getUnqual-113455.patch:
    - d/p/0015-Update-apis-incompatible-with-llvm-versions-in-codeg.patch:
    - d/p/0016-Revert-upstream-commit-32643bc9266271ebf3b935573189e.patch:
      Backport patches from upstream to fix the issue.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 10 Jun 2024 14:38:33 -0400

pytorch (2.1.2+dfsg-4) unstable; urgency=medium

  * Autopkgtest: do not run python tests -- too slow on our CI.
  * Autopkgtest: refresh C++ test list.
  * Autopkgtest: Disable dangling symlink test (may fail due to other package).
  * rules: Remove the dangling libnnapi_backend.so symlink.
  * Drop B-D on python3-distutils (Closes: #1065941).

 -- Mo Zhou <lumin@debian.org>  Wed, 24 Apr 2024 19:26:04 -0400

pytorch (2.1.2+dfsg-3) unstable; urgency=medium

  * Remove merged ppc64el FTBFS patch.
  * Remove the version requirement for libsleef-dev.
  * Update control file for CUDA variant. (Closes: #1064484)
  * <cuda> Require cutlass >= 3.1.0.

 -- Mo Zhou <lumin@debian.org>  Wed, 28 Feb 2024 12:06:31 -0500

pytorch (2.1.2+dfsg-2) unstable; urgency=medium

  [ Petter Reinholdtsen ]
  * Added patch numbering scheme README and rename patches to follow suit.

  [ Mo Zhou ]
  * Correct wrong patch numberings.
  * Control: Does not compile against sleef from git.
  * Upload to unstable. (Closes: #1060097)

 -- Mo Zhou <lumin@debian.org>  Tue, 13 Feb 2024 13:22:09 -0500

pytorch (2.1.2+dfsg-1) experimental; urgency=medium

  [ Petter Reinholdtsen ]
  * Updated Standards-Version from 4.6.0.1 to 4.6.2.  No changes needed.
  * Updated patch metadata based on git history.

  [ Mo Zhou ]
  * New upstream version 2.1.2+dfsg
  * README.Source: update dependency track list for v2.1.2
  * Update embedded kineto to 49e854d805d916b2031e337763928d2f8d2e1fbf.
    - Delete unwanted binary files from embedded kineto.
    * Patch embedded kineto to use system lib.
    + Embed a partial copy of dynolog for the embedded kineto.
      Recursive git submodule is not fun at all.
    * Remove more unnecessary files from embedded kineto.
    * We will remove kineto and disable it for PyTorch/v2.2.X.
  * Update debian/copyright:
    * d/copyright: Remove mimalloc from third_party dir. (Files-Excluded)
    * d/copyright: update for third_party/nvfuser.
  * Remove embedded nvfuser from debian/. We use the one in third_party.
  * Update patches:
    * Rebase existing patches.
    - Auto-regenerate flatbuffers and deprecate the flatbuffers patch.
    * Patch functorch code to fix FTBFS.
  * Update debian/rules:
    * Fix cmake find_package LLVM by hinting with correct path.
    * d/rules: Update versions and correct the version.
    * Install libnnapi_backend.so to libtorch2.1.
  * Update debian/control and other debhelper files:
    * Bump ABI/SOVERSION from 2.0 to 2.1. Update Breaks+Replaces accordingly.
    * Require build-dep libcpuinfo-dev >= 0.0~git20230113.6481e8b~.
    * Require build-dep libonnx-dev >= 1.14.1~.
    * Require build-dep libgloo-dev (>= 0.0~git20230519.597accf~).
    * Require build-dep libdnnl-dev (>= 3.1.1~).
    * Require build-dep libideep-dev (>= 0.0~git20230825.6f4d653~).
    * Remove build-dep version requirement on libflatbuffers-dev.
      Flatbuffer files are automatically re-generated during build now.
  * Specific changes to <cuda> variant.
    * <cuda> Reduce CUDA_ARCH_LIST to 6.1;7.5;8.6 for smaller binary.
  * Upload to experimental. Prepare for transition.

 -- Mo Zhou <lumin@debian.org>  Mon, 01 Jan 2024 00:26:26 -0500

=== debian/control ===
Source: pytorch
Section: science
Homepage: https://pytorch.org/
Priority: optional
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/deeplearning-team/pytorch.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/pytorch
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 12),
               dh-exec,
               dh-python,
               googletest,
#               glslc,
               libasio-dev,
               libavcodec-dev,
               libblas-dev,
               libbenchmark-dev,
               libcpuinfo-dev (>= 0.0~git20230113.6481e8b~),
               libdnnl-dev (>= 3.1.1~) [amd64 arm64 ppc64el s390x],
               libeigen3-dev,
               libfmt-dev,
               libfp16-dev (>= 0.0~git20200514.4dfe081~),
               libflatbuffers-dev,
               flatbuffers-compiler-dev,
               libfxdiv-dev (>= 0.0~git20200417.b408327~),
               libgloo-dev (>= 0.0~git20230519.597accf~) [amd64 arm64 ppc64el mips64el s390x riscv64],
               libideep-dev (>= 0.0~git20230825.6f4d653~) [amd64 arm64 ppc64el s390x],
               liblapack-dev,
               libleveldb-dev,
               liblmdb-dev,
               llvm,
               llvm-dev,
               libnop-dev,
               libnuma-dev,
               libonnx-dev (>= 1.14.1~),
               libopencv-dev,
               libprotobuf-dev,
               libprotoc-dev,
               libpsimd-dev (>= 0.0~git20200517.072586a~),
               libpthreadpool-dev (>= 0.0~git20210507.1787867~),
               libsleef-dev,
               libsnappy-dev,
               libtensorpipe-dev (>= 0.0~git20220513.bb1473a~),
#               libvulkan-dev,
#               libvulkan-memory-allocator-dev,
               libxnnpack-dev (>= 0.0~git20221221.51a9875~) [amd64 arm64 riscv64],
               libzmq3-dev,
               libzstd-dev,
               ninja-build,
               ocl-icd-opencl-dev,
               protobuf-compiler,
               pybind11-dev,
               python3,
               python3-dev,
               python3-cffi,
               python3-numpy,
               python3-onnx,
               python3-pybind11,
               python3-setuptools,
               python3-yaml

Package: python3-torch
Section: python
Architecture: amd64 arm64 mips64el ppc64el s390x kfreebsd-amd64 riscv64
Depends: libtorch2.1 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         libtorch-test (= ${binary:Version}),
# PyTorch's JIT (C++ Extension) functionality needs development files/tools.
Recommends: libtorch-dev (= ${binary:Version}),
            build-essential,
            ninja-build,
            pybind11-dev,
Suggests: python3-hypothesis, python3-pytest
Provides: ${python3:Provides}, python3-torch-api-2.1
Conflicts: python3-torch-cuda
Replaces: python3-torch-cuda
Description: Tensors and Dynamic neural networks in Python (Python Interface)
 PyTorch is a Python package that provides two high-level features:
 .
 (1) Tensor computation (like NumPy) with strong GPU acceleration
 (2) Deep neural networks built on a tape-based autograd system
 .
 You can reuse your favorite Python packages such as NumPy, SciPy and Cython
 to extend PyTorch when needed.
 .
 This is the CPU-only version of PyTorch (Python interface).

Package: libtorch-dev
Section: libdevel
Architecture: amd64 arm64 mips64el ppc64el s390x kfreebsd-amd64 riscv64
Depends: libtorch2.1 (= ${binary:Version}),
         python3-dev,
         libprotobuf-dev,
         ${misc:Depends}
Conflicts: libtorch-cuda-dev
Replaces: libtorch-cuda-dev
Description: Tensors and Dynamic neural networks in Python (Development Files)
 PyTorch is a Python package that provides two high-level features:
 .
 (1) Tensor computation (like NumPy) with strong GPU acceleration
 (2) Deep neural networks built on a tape-based autograd system
 .
 You can reuse your favorite Python packages such as NumPy, SciPy and Cython
 to extend PyTorch when needed.
 .
 This is the CPU-only version of PyTorch (Development files).

Package: libtorch2.1
Section: libs
Architecture: amd64 arm64 mips64el ppc64el s390x kfreebsd-amd64 riscv64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Recommends: libopenblas0 | libblis3 | libatlas3-base | libmkl-rt | libblas3,
Conflicts: libtorch1.13, libtorch-cuda-1.13,
           libtorch2.0, libtorch-cuda-2.0,
           libtorch-cuda-2.1,
Replaces: libtorch1.13, libtorch-cuda-1.13,
          libtorch2.0, libtorch-cuda-2.0,
          libtorch-cuda-2.1,
Description: Tensors and Dynamic neural networks in Python (Shared Objects)
 PyTorch is a Python package that provides two high-level features:
 .
 (1) Tensor computation (like NumPy) with strong GPU acceleration
 (2) Deep neural networks built on a tape-based autograd system
 .
 You can reuse your favorite Python packages such as NumPy, SciPy and Cython
 to extend PyTorch when needed.
 .
 This is the CPU-only version of PyTorch (Shared Objects).

Package: libtorch-test
Section: libs
Architecture: amd64 arm64 mips64el ppc64el s390x kfreebsd-amd64 riscv64
Depends: libtorch2.1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
Conflicts: libtorch-cuda-test
Replaces: libtorch-cuda-test
Description: Tensors and Dynamic neural networks in Python (Test Binaries)
 PyTorch is a Python package that provides two high-level features:
 .
 (1) Tensor computation (like NumPy) with strong GPU acceleration
 (2) Deep neural networks built on a tape-based autograd system
 .
 You can reuse your favorite Python packages such as NumPy, SciPy and Cython
 to extend PyTorch when needed.
 .
 This is the CPU-only version of PyTorch (Test Binaries).

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export LC_ALL=C.UTF-8
export PYBUILD_DISABLE_python2 = 1
export PYBUILD_NAME = torch
export PYTORCH_BUILD_VERSION = $(shell echo "$(DEB_VERSION_UPSTREAM)" | sed -e 's/+dfsg.*$//')
export PYTORCH_VERSION = $(shell echo "$(DEB_VERSION_UPSTREAM)" | sed -e 's/+dfsg.*$//')
export SOVERSION = 2.1
export PATCH = 2

# --[[ maintainer notes ]]--
# How to dump the flags for the upstream built instance:
# $ python3 -c 'import torch as th; print(th.__version__, th.__config__.show())'

ifneq (,$(shell command -v nvcc))
export CUDA_HOME=/usr
export CC=cuda-gcc
export CXX=cuda-g++
export BUILD_SPLIT_CUDA=ON  # this is a workaround to linker overflow
# Refer the following webpage for CUDA capacity of different GPUs:
#   https://developer.nvidia.com/cuda-gpus
# Note, cuda compute architecture is backward compatible. Thus, even if we
# compile the package in the config 2 ("all-major"), it still runs on the
# GPUs produced as of 2015. Note, we may encounter linker overflow because
# the binary is too large, containing binary code for way too many archs.
# -- config 1: cover popular archs (default) --
export TORCH_CUDA_ARCH_LIST = 6.1;7.5;8.6
# -- config 2: cover only major archs. --
#export TORCH_CUDA_ARCH_LIST = 6.0;7.0;8.0
# -- config 3: cover as more arch as possible, and PTX --
#export TORCH_CUDA_ARCH_LIST = 6.0;6.1;7.0;7.5;8.0;8.6+PTX
endif

# [special blas configurations]
# We use a run-time switching mechanism for BLAS/LAPACK.
# https://wiki.debian.org/DebianScience/LinearAlgebraLibraries
# Even if the torch package is built against the generic library, the backend
# libblas.so.3 is in fact automatically switched to the fastest implementation.
export BLAS = Generic
export GENERIC_BLAS_LIBRARIES = blas

# [misc configurations]
export _WNOERROR_ = -Wno-dangling-reference
ifneq (,$(shell command -v mold))
export LD=mold
export __LD=-fuse-ld=mold
else
ifneq (,$(shell command -v lld))
export LD=lld
export __LD=-fuse-ld=lld
else
export LD=ld
export __LD=
endif
endif
export CFLAGS = $(shell dpkg-buildflags --get CPPFLAGS) \
                $(shell dpkg-buildflags --get CFLAGS) \
                -gsplit-dwarf $(_WNOERROR_) $(__LD) -I/usr
export CXXFLAGS = $(shell dpkg-buildflags --get CPPFLAGS) \
                  $(shell dpkg-buildflags --get CXXFLAGS) \
                  -gsplit-dwarf $(_WNOERROR_) $(__LD) -I/usr
export ONNX_NAMESPACE = onnx
export REL_WITH_DEB_INFO = ON
export USE_FFMPEG = ON
export USE_GFLAGS= OFF
export USE_GLOG = OFF
export USE_LEVELDB = ON
export USE_LMDB = ON
export USE_OPENCV = ON
export USE_REDIS = OFF
export USE_SYSTEM_LIBS = ON
export USE_ZMQ = ON
export USE_ZSTD = ON
export USE_KINETO = ON
export USE_ITT = OFF
export BUILD_CAFFE2 = 0
export BUILD_CAFFE2_OPS = 0
export USE_LLVM = $(shell llvm-config --prefix)

# [device specific -- Vulkan backend support]
# See https://pytorch.org/tutorials/prototype/vulkan_workflow.html
#export USE_VULKAN=1
#export USE_VULKAN_SHADERC_RUNTIME=1
#export USE_VULKAN_WRAPPER=0

# [device specific -- CPU/CUDA/ROCm configurations]
ifneq (,$(shell command -v nvcc))
# CUDA version
export NO_CUDA = 0
export USE_CUDA = ON
export USE_CUDNN = ON
export USE_SYSTEM_NCCL = ON
export USE_ROCM = OFF
export USE_MIOPEN = OFF
export USE_MAGMA = OFF
else ifneq (,$(shell command -v hipcc))
# ROCm version
export NO_CUDA = 1
export USE_CUDA = OFF
export USE_ROCM = ON
export USE_MIOPEN = ON
else
# CPU version
export NO_CUDA = 1
export USE_CUDA = OFF
export USE_CUDNN = OFF
export USE_SYSTEM_NCCL = OFF
export USE_ROCM = OFF
export USE_MIOPEN = OFF
endif

# [distributed/communication configurations]
export USE_DISTRIBUTED = ON
export USE_GLOO = ON
export USE_MPI = OFF
export USE_TENSORPIPE = ON

# [CPU training and inference]
export USE_FBGEMM = OFF  # XXX: forget this; No need to enable.
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 ppc64el))
export USE_MKLDNN = ON  # requires ideep and onednn.
else
export USE_MKLDNN = OFF
endif
ifneq (,$(filter $(DEB_HOST_ARCH),amd64))
export USE_PYTORCH_QNNPACK = ON
else
export USE_PYTORCH_QNNPACK = OFF
endif
export USE_NNPACK = OFF  # XXX: forget this. No need to enable.
export USE_QNNPACK = OFF  # XXX: Deprecated upstream. No need to enable.
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 riscv64))
export USE_XNNPACK = ON
else
export USE_XNNPACK = OFF
endif

# [number of jobs]
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
export MAX_JOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# Customization options (You may want to rebuild this package locally)
NATIVE :=
ifneq (,$(NATIVE))
export CFLAGS = $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS) -gsplit-dwarf -march=native
export CXXFLAGS = $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS) -gsplit-dwarf -march=native
endif


%:
	dh $@ -Spybuild --with python3

override_dh_auto_clean:
	dh_auto_clean
	-find . -type d -name __pycache__ -exec rm -rf '{}' +
	-$(RM) -rf third_party/nvfuser
	-$(RM) -rf third_party/googletest
	-$(RM) -rf third_party/valgrind-headers

override_dh_auto_configure:
	cd third_party/; rmdir googletest; cp -rv /usr/src/googletest .
	cd third_party/; cp -rv ../debian/valgrind-headers .
	# fix python and shell shebang -- no /usr/bin/env
	find . -type f -name '*.py' -exec sed -i -e 's@#!/usr/bin/env python.*@#!/usr/bin/python3@' '{}' \;
	find . -type f -name '*.sh' -exec sed -i -e 's@#!/usr/bin/env @#!/usr/bin/@g' '{}' \;
	# regenerate flatbuffers code. See tools/gen_flatbuffers.sh
	cd torch/csrc/jit/serialization/; flatc --cpp --gen-mutable --scoped-enums mobile_bytecode.fbs 

override_dh_auto_build:
	true # In order to avoid building everything twice.

override_dh_auto_test:
	true

# [maintainer note] The build results in many shared objects ...
# but not all of them are important. You may check the contents of the
# upstream release of libtorch binary tarball in https://pytorch.org/
# for the list of most important shared objects.
# Alternatively, you may browse the conda-meta/pytorch-*.json files
# under an anaconda instance.
override_dh_auto_install:
	# [build and install]
ifneq (,$(shell command -v nvcc))
    # --- CUDA variant
	for PY in $(shell py3versions -d); do\
        $$PY setup.py install --install-layout=deb \
		--root=$(shell pwd)/debian/python3-torch-cuda/ ;\
        done
else ifneq (,$(shell command -v hipcc))
    # --- ROCM variant
	false # not impl
else
    # --- CPU variant
	for PY in $(shell py3versions -d); do \
        $$PY setup.py install --install-layout=deb \
		--root=$(shell pwd)/debian/python3-torch/ ;\
        done
endif
	# [list shared objects] use `ls build/lib/*.so` to get a list of all compiled shared objects.
	echo {begin listing shared objects}
	find build/lib -type f | sort
	echo {end listing shared objects}
	# [python3-torch::headers -> libtorch-dev] move the headers out of the python package
ifneq (,$(shell command -v nvcc))
    # --- CUDA variant
	mkdir -pv debian/libtorch-cuda-dev/usr/include
	mv -v debian/python3-torch-cuda/usr/lib/python3*/dist-packages/torch/include/* \
		debian/libtorch-cuda-dev/usr/include/
	cd debian/python3-torch-cuda/usr/lib/python3*/dist-packages/torch/include/; \
		ln -sv /usr/include/ATen . ;\
		ln -sv /usr/include/c10 . ;\
		ln -sv /usr/include/caffe2 . ;\
		ln -sv /usr/include/torch . ;\
        true
else ifneq (,$(shell command -v hipcc))
    # --- ROCM variant
	false
else
    # --- CPU variant
	mkdir -pv debian/libtorch-dev/usr/include
	mv -v debian/python3-torch/usr/lib/python3*/dist-packages/torch/include/* \
		debian/libtorch-dev/usr/include/
	cd debian/python3-torch/usr/lib/python3*/dist-packages/torch/include/; \
		ln -sv /usr/include/ATen . ;\
		ln -sv /usr/include/c10 . ;\
		ln -sv /usr/include/caffe2 . ;\
		ln -sv /usr/include/torch . ;\
        true
endif

=== debian/tests/control ===
# Sanity test of python package
Test-Command: cd test/ ; python3 -c "import sys, torch as th; print(sys.version, th.__path__, th.__version__)"
Depends: python3-torch,
Restrictions: allow-stderr
Features: test-name=py_import_and_version

Test-Command: cd debian/tests ; python3 blas.py
Depends: python3-torch, libopenblas0
Restrictions: allow-stderr
Features: test-name=py_blas_openblas

Test-Command: cd debian/tests ; python3 blas.py
Depends: python3-torch, libblis4
Restrictions: allow-stderr
Features: test-name=py_blas_blis

Test-Command: cd debian/tests ; python3 sequential.py
Depends: python3-torch,
Restrictions: allow-stderr
Features: test-name=py_sequential

# Check dangling symbol links
#Test-Command: cd debian/tests ; export TH_PATH="$(python3 -c 'import torch; print(torch.__path__[0])')"; test -z "$(find ${TH_PATH}/lib -xtype l)"
#Depends: python3-torch,
#Restrictions: allow-stderr
#Features: test-name=py_torch_no_dangling_symlink

# We are only printing those for package maintainers. The find command may fail due to a dangling symlink from other packages.
Test-Command: cd debian/tests ; find /usr -xtype l -print || true
Depends: @
Restrictions: allow-stderr
Features: test-name=show_dangling_symlink_if_any

# Generating Autopkgtest Test Cases for the C++ Testing Programs
# Found 100 tests
#
# C++ test 0/100
Test-Command: /usr/lib/libtorch-test/CppSignature_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=1_of_100__cpptest__CppSignature_test
Restrictions: allow-stderr

# C++ test 1/100
Test-Command: /usr/lib/libtorch-test/Dict_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=2_of_100__cpptest__Dict_test
Restrictions: allow-stderr

# C++ test 2/100
Test-Command: /usr/lib/libtorch-test/Dimname_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=3_of_100__cpptest__Dimname_test
Restrictions: allow-stderr

# C++ test 3/100
Test-Command: /usr/lib/libtorch-test/IListRef_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=4_of_100__cpptest__IListRef_test
Restrictions: allow-stderr

# C++ test 4/100
Test-Command: /usr/lib/libtorch-test/KernelFunction_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=5_of_100__cpptest__KernelFunction_test
Restrictions: allow-stderr

# C++ test 5/100
Test-Command: /usr/lib/libtorch-test/List_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=6_of_100__cpptest__List_test
Restrictions: allow-stderr

# C++ test 6/100
Test-Command: /usr/lib/libtorch-test/MaybeOwned_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=7_of_100__cpptest__MaybeOwned_test
Restrictions: allow-stderr

# C++ test 7/100
Test-Command: /usr/lib/libtorch-test/NamedTensor_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
